//Made for Teensy 2.0

HardwareSerial Uart = HardwareSerial();


const int PWM1 = 12;  
const int PWM2 = 10; 
const int gnd =  11;
const int led =  9;

int recStat = 0;
int index = 0;  

long previousMillis = 0; 
long differenz = 0; 
long intervall = 200;  // this sets the maximum amount of time to wait until motor stop



void setup() {
  // initialize serial:
  Serial.begin(115200);
  Uart.begin(9600);   
  pinMode(PWM1, OUTPUT);   
  pinMode(PWM2, OUTPUT); 
  pinMode(gnd, OUTPUT); 
  pinMode(led, OUTPUT); 
  digitalWrite(gnd, LOW);
  digitalWrite(led, LOW);
  dac(1, 125); 
  dac(2, 125);
  delay(5000);
}

void loop() {
  
  while(Uart.available() > 0) // Waiting for UART data in this format: Byte,Byte,Byte,NewLine
    { 
    
    recStat = 0;
    
    int throttle = Uart.parseInt(); 
    int steering = Uart.parseInt();
    int unimportant = Uart.parseInt(); 

    if (Uart.read() == 13) { //NL received
      if (throttle > 255) throttle = 255;
      dac(1, throttle );  
      if (steering  > 255) steering  = 255;
      dac(2, steering);  
      Uart.print(throttle, DEC); //Send data back via UART
      Uart.print(" ");
      Uart.print(steering, DEC);
      Uart.print(" ");
      Uart.println(unimportant, DEC);
    }
  }
      
   unsigned long currentMillis = millis();
   if (currentMillis - previousMillis > intervall) {
   previousMillis = currentMillis;  
   if (recStat){
      dac(1, 125);   //Motor Stop
      dac(2, 125);   //Motor Stop
      digitalWrite(led, HIGH); // LED shows that no data arrived longer than 200ms
   }  else digitalWrite(led, LOW);  
   recStat = 1;
  } 
 
}



 void dac(int kanal, int value)
 {
  int bla1;

  bla1 = map(value, 0, 255 , 31, 224); // the control unit does not accept the full DAC range. 
  bla1 = map(value, 0, 255 , 31, 227);
  
  if(kanal == 2){
   analogWrite(PWM1, bla1); //Data
   }
   if(kanal == 1){
   analogWrite(PWM2, bla1);
   }
 } 
